import("stdfaust.lib");

freq = hslider("freq-ref", 220, 20, 5000, 1);
tempo = hslider("tempo [unit:bpm]", 60, 10, 240, 1);
gate = checkbox("gate");
alea = checkbox("alea");

// rythme 
period = ma.SR*60/(tempo*1);
maxDelay = period*4;
bpm =100;

trig1 = ba.pulsen(1, period) ;
trig2 = trig1 : de.delay (maxDelay, period * 1 );
trig = trig1 + trig2;

// hauteur - mélodique
nnotes = hslider("nnotes", 6, 1, 24, 1);
freq2 = no.lfnoise0(bpm) : ba.sAndH (trig) :+(1):*(12):+(36):int:ba.pianokey2hz;
line = os.phasor(1, tempo/(60*nnotes)) ;

line2 = line * nnotes : ma.decimal;
freq3 = freq + (freq2-220)*alea ;
son = os.osci(freq3)*0.04;
process = son*gate<:_,_ ;